Bug 17821 - update of french-dvorak "bépo" keyboard mapping
Summary: update of french-dvorak "bépo" keyboard mapping
Status: RESOLVED FIXED
Alias: None
Product: xkeyboard-config
Classification: Unclassified
Component: General (show other bugs)
Version: unspecified
Hardware: Other All
: medium normal
Assignee: xkb
QA Contact:
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-09-28 23:38 UTC by Frédéric Boiteux
Modified: 2008-12-12 03:50 UTC (History)
2 users (show)

See Also:
i915 platform:
i915 features:


Attachments
update french dvorak layout "bépo" up to 1.0rc2 version. (18.30 KB, patch)
2008-09-30 00:21 UTC, Frédéric Boiteux
Details | Splinter Review
update of my previous patch (18.33 KB, patch)
2008-11-11 12:34 UTC, Frédéric Boiteux
Details | Splinter Review
last version of patch, without greek dead key. (18.17 KB, patch)
2008-12-11 13:22 UTC, Frédéric Boiteux
Details | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Frédéric Boiteux 2008-09-28 23:38:37 UTC
Hello,

Two years after ist first inclusion in Xorg, the french dvorak layout "bépo" has evolved to its 1.0rc2 revision (see http://clavier-dvorak.org/wiki/) and people who have enhanced it would like to put their last version back in Xorg tree.

  You'll find a patch as attachment. please contact me if you have any comment with it. As specific things in our layout, we have defined some new dead ("composing") keys with some unused UTF-8 codes, like UFDD1 for a dead monetary key : Compose+this key+S gives dollar, +e gives euro sign, etc.
Comment 1 Sergey V. Udaltsov 2008-09-29 16:25:21 UTC
So, where's the attachment? ;)
Comment 2 Frédéric Boiteux 2008-09-30 00:21:34 UTC
Created attachment 19303 [details] [review]
update french dvorak layout "bépo" up to 1.0rc2 version.

Here it is, sorry to forget it first time !
Comment 3 Sergey V. Udaltsov 2008-09-30 01:12:55 UTC
Great, I'll commit it asap. But since I rolled release 1.4 last night, this one will be part of 1.5 (in 4 months)
Comment 4 Frédéric Boiteux 2008-09-30 01:18:58 UTC
Gasp ! I'll be more careful next time !!
Comment 5 James Cloos 2008-09-30 12:55:06 UTC
There is a problem with that patch which I discovered while evaluating
the associated attachment 19277 [details] [review] to the bug requesting Compose sequences.

The submitter uses UFDD[0-3] symbols in lieu of some desired dead keys:

  UFDD0 in lieu of the existing dead_stroke
  UFDD1 in lieu of a dead_currency symbol
  UFDD2 in lieu of a dead_greek symbol
  UFDD3 in lieu of a dead_comma symbol

All instances of UFDD0 in the patch should be of dead_stroke.

I’m not sure what will happen with the other three.  In the pre-utf8
locales dead_cedilla did double duty as a dead_comma for those locales
which have U+0218 thru U+012B (ȘșȚț) instead of U+015E, U+015F, U+0162
and U+0163 (ŞşŢţ).  I’ll ask for some consensus about adding dead_comma
and even dead_currency (which perhaps should have a better name).

Adding a dead_greek seems unlikely, however.
Comment 6 Sergey V. Udaltsov 2008-09-30 13:07:44 UTC
> and U+0163 (ŞşŢţ).  I’ll ask for some consensus about adding dead_comma
> and even dead_currency (which perhaps should have a better name).
Will I wait till at least dead_comma and dead_currency are available?
Comment 7 James Cloos 2008-09-30 14:50:32 UTC
> Will I wait till at least dead_comma and dead_currency are available?

I suppose I would commit it with the dead_stroke change and without the
other UFDDx symbols, pending a final update.
Comment 8 Sergey V. Udaltsov 2008-09-30 15:10:21 UTC
Frederic, what's your opinion?
Comment 9 Frédéric Boiteux 2008-09-30 23:59:29 UTC
About the UFDDx dead keys, I mentioned it as I thought it could be a problem. When we use these numbers to define new dead keys, we didn't know about dead_stroke existence. I found a file with keysyms.txt, but it is obviously out of date : could you tell me where to find the latest one, I'm lost in the whole X.org software ?
So the UFFD0 should be replaced by 'dead_stroke', it's cleaner.

About the 'dead_comma' (UFDD3), it don't give the same characters as the dead_cedilla (which is also present in the Bépo layout), so the former can't be 
replaced by the latter.

It could be really nice if new dead_* symbols could be defined in place of these UFDD* hacks, and I prefer to wait for them and then submit new patches with Bépo layout and Compositions updated (as I missed the xkeyboard-config release deadline, it could wait for some days...).

And for the dead_greek code, yes, you could achieve the same result with groups, but :
- our keyboard layout has been defined with OS independance in mind (ever if I used only Unix-like OS, other people has a driver for Windows or Mac OS systems), and I'm not sure the group mechamisn could be realized in those other OS.
- it is more consistent with the behaviour of the layout, which defines some dead keys to be able to add some foreign [for french] characters with a simple composition.
If such a dead_greek keysym isn't added, could we include the Bépo Layout in Xorg with its existing UFDD2 code ?

  Fred.


P.S.: I don't know in bugzilla how to post a comment on two [related] bugs, i.e. 17821 and 17822, so I'll copy it from one to the other...
Comment 10 Simos Xenitellis 2008-10-01 03:10:15 UTC
I am probably missing something basic here.

Why do we need a new dead key dead_greek in the line

key <AB08> { [ g, G, UFDD2                 ] }; // g G µ

Could it be merely written as

key <AB08> { [ g, G, U00B5                 ] }; // g G µ
Comment 11 Frédéric Boiteux 2008-10-01 06:32:43 UTC
To Simos : in the comment (and in the keyboard layout picture), we left a greek letter, mu, to have a visual representation of this dead greek letter, but this key does much than mu : you can get all the greek alphabet by combining it with latin letters, as defined in the patch of bug 17822 .

About dead stoke, as the keysym already exists, I should examine current Compositions for existing ones with this keysym, to be sure to remove any redondancies or conflicts in the patch of bug 17822.
Comment 13 Frédéric Boiteux 2008-10-03 05:31:27 UTC
Thanks for the links to keysymdef.h !

I've reviewed my libX11's patch about UFDD0 replaced to dead_stroke : I've found 21 redundancies between standard libX11 compositions and ones I'd like to add, so I should remove these 21 lines in my patch. I'd also like to replace UTF-8 codes (UXXXX) by definitions from latest keysymdef.h I've downloaded.

So, before to submit an updated patch, I'd like to know if a dead_currency, dead_greek and dead_commabelow (more than dead_comma) will be created : I'll update both my xkeyboard-config and libX11 patches accordingly.

If you have better names for these dead_keys, please use them.

If the dead_greek can't be added, I'd like to keep the UFDDx code instead.
Comment 14 Frédéric Boiteux 2008-11-11 12:34:54 UTC
Created attachment 20223 [details] [review]
update of my previous patch

This is an update of the previous patch, correcting some errors in the layout, and taking account of dead_stroke and dead_belowcomma defined in libX11.
Comment 15 Frédéric Boiteux 2008-12-11 13:22:50 UTC
Created attachment 21068 [details] [review]
last version of patch, without greek dead key.

  Hello,

  I finally gave up about greek dead key, after trying solutions with ISO_level5_latch and multiple groups, each solution having important drawbacks.
So, I propose a final patch, to let this Bépo layout be updated.

  As the greek keys compositions can't be used, the 17822 bug can be also closed.


  with regards,
     Fred.
Comment 16 Sergey V. Udaltsov 2008-12-12 03:50:25 UTC
Sweet! Thanks, committed!



Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.